var imIFrames = new Array();

function loadImFrame( containerID, param, hash ) {
	imIFrames[ containerID ].loadFrame( param, hash );
};

function IMIframe( containerID, URLBase, shouldCache ) {
	imIFrames[ containerID ] = this;
	this.URLBase = URLBase;
	this.cache = new Array();
	this.shouldCache = shouldCache;
	this.currentFrame = null;
	this.rootElement = document.getElementById( containerID );
	this.rootElement.style.position = "relative";

	this.createFrame = function( param ) {
		if ( this.cache[ param ] != null ) {
			return this.cache[ param ];
		}
		var res = document.createElement( 'iframe' );
		res.frameBorder = "0";
		res.className = "imIframe";
		res.setAttribute( "src", this.URLBase + param );
		res.frameID = param;
		this.rootElement.appendChild( res );
		if ( this.shouldCache ) {
			this.cache[ param ] = res;
		}
		return res;
	};

	this.loadFrame = function( param, hash ) {
		if ( this.currentFrame != null ) {
			if ( this.currentFrame.frameID == param ) {
				if ( hash ) {
					this.currentFrame.contentWindow.document.location.hash = hash;
				}
				// nothing to do
				return;
			}
			// detach
			this.currentFrame.style.display = "none";
		}
		this.currentFrame = this.createFrame( param );
		this.currentFrame.style.display = "";
		if ( hash ) {
			this.currentFrame.contentWindow.document.location.hash = hash;
		}
	};
}